/* ========================================
 *  ConsoleLABuss - ConsoleLABuss.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) Airwindows, Airwindows uses the MIT license
 * ======================================== */

#ifndef __ConsoleLABuss_ConsoleLABuss_H
#define __ConsoleLABuss_ConsoleLABuss_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::ConsoleLABuss {
enum {
	kParamA = 0,
  kNumParameters = 1
}; //


class ConsoleLABuss final : public SfxCoreExtensionV1
{
public:
    ConsoleLABuss();
    ~ConsoleLABuss();
    void processBlock(float** inputs, float** outputs, int sampleFrames) override;
    int getParameterCount() const override;
    float getParameter(int index) override;
    void setParameter(int index, float value) override;
    void getParameterLabel(int index, char *text) override;
    void getParameterName(int index, char *text) override;
    void getParameterDisplay(int index, char *text) override;
private:
    
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff
	
	double lastSinewL;
	double lastSinewR;
	
	double subAL;
	double subAR;
	double subBL;
	double subBR;
	double subCL;
	double subCR;
	
	double gainA;
	double gainB; //smoothed master fader for channel, from Z2 series filter code

    float A;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
